#ifndef PANEL_OPTIMIZE_H
#define PANEL_OPTIMIZE_H

#ifndef PANEL_H
#include "Panel.h"
#endif

#ifndef DYNAMIC_SINGLETON_H
#include "Dynamic_singleton.h"
#endif

#ifndef UI_PANEL_DYNAMICS_H
#include "ui_Panel_optimize.h"
#endif

//#ifndef MODEL_SINGLETON_VIEW_H
//#include "Model_singleton_view.h"
//#endif


namespace MM
{
class Gradient_minimizer;
class Main_window;

class Panel_optimize
:
    public Panel,
    public Ui_Panel_optimize,
    //public Model_singleton_view,
    public Dynamic_singleton <Panel_optimize>
{
    Q_OBJECT

    Main_window *           player_;
    Gradient_minimizer *    minimizer_;

public:    
    Panel_optimize ();

public slots:
    //void                set_method (const QString & text);
    void                set_advanced (bool);

//    void                barostat        (int on);
//    void                thermostat      (int on);
//    void                show_thermostat (const QString & type);
//    void                set_temperature (double);
//    void                set_steps       (double);
//
//    void                renew_current_model (Model &);
//    void                renew (Model_event::Hint hint 
//                            = Model_event::Structure_changed);
//
//    //void                run (bool);
    void                run   ();
//    //void            check ();
//    void                tune  ();
//    void                start ();
    void                stop  ();

protected:
    void                set_stop_state ();
    void                set_run_state  ();

    void                turn (bool on);
    void                closeEvent (QCloseEvent * event);
};

}//MM

#endif //PANEL_OPTIMIZE_H
